<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<!DOCTYPE html>
<%@taglib prefix="spring" uri="http://www.springframework.org/tags"%>
<%@taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
    <title>WebSockets</title>

    <link type="text/css" href="<c:url value="/resources/css/screen.css"/>" rel="stylesheet" />
    <link type="text/css" href="<c:url value="/resources/css/styles.css"/>" rel="stylesheet" />
    <link type="text/css" href="<c:url value="/resources/css/smoothness/jquery-ui-1.8.18.custom.css"/>" rel="stylesheet" />
    <script type="text/javascript" src="<c:url value="/resources/js/jquery-1.7.1.min.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery-ui-1.8.18.custom.min.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery.cookie.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/backbone-min.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery.colorpicker.js" />"></script>
    <script type="text/javascript" src="<c:url value="/resources/js/jquery.mousewheel.js" />"></script>

    <script type="text/javascript">
        var rooms = [
            {"roomId": 0, "roomName": "Raum 1"},
            {"roomId": 1, "roomName": "Raum 2"},
            {"roomId": 2, "roomName": "Raum 3"},
            {"roomId": 3, "roomName": "Raum 4"}
        ];
        var volumes = {"room1":0,"room2":0,"room3":0,"room4":0};
        var devices;
        $(document).ready(
                function() {


                    function sendData(data) {
                        $.ajax({
                            type: 'POST',
                            url: "/control/devices",
                            contentType: "application/json",
                            dataType: "json",
                            data: JSON.stringify(data)
                        });
                        console.log(data);
                        console.log(JSON.stringify(data));
                    }

                    var senden = function sendOutAllDevices() {
                        var changedDevs = new Array();
                        for(var i=0;i<devices.length;i++) {
                            if(devices[i].type=="Par56Spot" && devices[i].dirty) {
                                delete devices[i].dirty;
                                var dev = {"deviceId": i, "options":{"red":devices[i].red, "green":devices[i].green, "blue":devices[i].blue}};
                                changedDevs.push(dev);
                            }
                        }
                        if (changedDevs.length > 0) {
                            sendData({"timeStamp": Math.round(new Date().getTime()/1000), "updates": changedDevs});
                        }
                        console.log("set new interval for sending");

                    };
                    window.setInterval(senden, 100);

                    $("#slider1").slider({ min: 0, max: 100, slide: function(event, ui) {
                        volumes.room1 = ui.value;
                        dataChanged = true;
                    } });

                    $("#slider2").slider({ min: 0, max: 100, slide: function(event, ui) {
                        volumes.room2 = ui.value;
                        dataChanged = true;
                    } });

                    $("#slider3").slider({ min: 0, max: 100, slide: function(event, ui) {
                        volumes.room3 = ui.value;
                        dataChanged = true;
                    } });

                    $("#slider4").slider({ min: 0, max: 100, slide: function(event, ui) {
                        volumes.room4 = ui.value;
                        dataChanged = true;
                    } });
                    $("#tabs").tabs();
                    $("#v-tabs").tabs().addClass('ui-tabs-vertical');
                    $(".lampel .circle").click(function() {
                        if($(this).hasClass('black')){
                            $(this).removeClass('black');
                        } else {
                            $(this).addClass('black');
                        }
                    });
                    var colorpicker_raum1 = new jQuery.ColorPicker('#colorpicker-raum1', {
                        imagepath: '/resources/images/colorpicker/',
                        change: function(hexcolor) {
                            var red = hexcolor.substr(1,2);
                            var green = hexcolor.substr(3,2);
                            var blue = hexcolor.substr(5,2);
                            $('#par56select option:selected').each(function() {
                                devices[$(this).attr('name')].red = parseInt(red, 16);
                                devices[$(this).attr('name')].green = parseInt(green, 16);
                                devices[$(this).attr('name')].blue = parseInt(blue, 16);
                                devices[$(this).attr('name')].dirty = true;
                            });
                            console.log("data changed" + hexcolor);

                        }
                    });
                    $.getJSON('/control/devices', function(data) {
                        devices = data;
                        for(var i=0;i<devices.length;i++) {
                            if(devices[i].type=="Par56Spot") {
                                $('#par56select').append("<option name=" + devices[i].deviceId + ">" + devices[i].deviceName + "</option>");
                            }
                        }

                    });
                    $('.buzzer button').click(function() {
                        var span = $(this).parent().find('span');
                        span
                                .toggleClass('red')
                                .toggleClass('green');
                        if(span.text() == "Auf") {
                            span.text("Zu");
                        } else {
                            span.text("Auf");
                        }

                    })
                    $('#par56select').change(function() {
                        $('#par56select option:selected').each(function() {
                            var red = devices[$(this).attr('name')].red.toString(16);
                            var green = devices[$(this).attr('name')].green.toString(16);
                            var blue = devices[$(this).attr('name')].blue.toString(16);
                            if(red.length == 1) {
                                red += red;
                            }
                            if(green.length == 1) {
                                green += green;
                            }
                            if(blue.length == 1) {
                                blue += blue;
                            }
                            var hexstring = '#' + red + green + blue;
                            console.log("lampe:" + hexstring);
                            colorpicker_raum1.hex(hexstring);
                        });
                    });
                }
        );

    </script>
</head>
<body>
    <h1>CTDO Raumsteuerung</h1>

    <div id="tabs">
        <ul>
            <li><a href="#tabs-1">Global</a></li>
            <li><a href="#tabs-2">Raum 1</a></li>
        </ul>
        <div id="tabs-1">

            <div class="buzzer">
                <span class="circle red">Zu</span>
                <button>Buzzern</button>
            </div>
        </div>
        <div id="tabs-2">
            <div id="v-tabs" class="inner-tabs-container">
                <ul>
                    <li><a href="#v-tabs-1">Licht</a></li>
                    <li><a href="#v-tabs-2">Musik</a></li>
                    <li><a href="#v-tabs-3">Lampel</a></li>
                </ul>
                <div id="v-tabs-1">
                    <div id="colorpicker-raum1"></div>
                    <select multiple="multiple" id="par56select">

                    </select>
                </div>
                <div id="v-tabs-2">
                    <label for="slider1">Lautstärke Raum 1:</label><div id="slider1" class="slider"></div>
                </div>
                <div id="v-tabs-3">
                    <div class="lampel">
                        <span class="circle red" title="click to toggle"></span>
                        <span class="circle yellow" title="click to toggle"></span>
                        <span class="circle green" title="click to toggle"></span>

                    </div>

                </div>
            </div>

            <div class="switch">
                Raumlicht:<br />
                <input type="radio" name="raum-1-licht">An <input type="radio" name="raum-1-licht" checked="checked">Aus
            </div>

        </div>
    </div>
</body>
</html>